VERSION 5.00
Object = "{831FDD16-0C5C-11D2-A9FC-0000F8754DA1}#2.0#0"; "MSCOMCTL.OCX"
Begin VB.Form frmMain 
   Caption         =   "List View Column Totals Example"
   ClientHeight    =   3660
   ClientLeft      =   1155
   ClientTop       =   1545
   ClientWidth     =   4980
   LinkTopic       =   "Form1"
   ScaleHeight     =   3660
   ScaleWidth      =   4980
   Begin VB.CommandButton cmdNewData 
      Caption         =   "&New Data"
      Height          =   495
      Left            =   1800
      TabIndex        =   3
      Top             =   2505
      Width           =   870
   End
   Begin VB.CommandButton cmdExit 
      Cancel          =   -1  'True
      Caption         =   "E&xit"
      Height          =   495
      Left            =   2895
      TabIndex        =   2
      Top             =   2520
      Width           =   870
   End
   Begin VB.CommandButton cmdTotal 
      Caption         =   "&Total"
      Height          =   495
      Left            =   750
      TabIndex        =   1
      Top             =   2520
      Width           =   870
   End
   Begin MSComctlLib.ListView ListView1 
      Height          =   1845
      Left            =   630
      TabIndex        =   0
      Top             =   615
      Width           =   3735
      _ExtentX        =   6588
      _ExtentY        =   3254
      View            =   3
      LabelWrap       =   -1  'True
      HideSelection   =   -1  'True
      _Version        =   393217
      ForeColor       =   -2147483640
      BackColor       =   -2147483643
      BorderStyle     =   1
      Appearance      =   1
      BeginProperty Font {0BE35203-8F91-11CE-9DE3-00AA004BB851} 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      NumItems        =   4
      BeginProperty ColumnHeader(1) {BDD1F052-858B-11D1-B16A-00C0F0283628} 
         Key             =   "RowTitle"
         Object.Width           =   2540
      EndProperty
      BeginProperty ColumnHeader(2) {BDD1F052-858B-11D1-B16A-00C0F0283628} 
         SubItemIndex    =   1
         Key             =   "Column1"
         Text            =   "Column 1"
         Object.Width           =   1270
      EndProperty
      BeginProperty ColumnHeader(3) {BDD1F052-858B-11D1-B16A-00C0F0283628} 
         SubItemIndex    =   2
         Key             =   "Column2"
         Text            =   "Column 2"
         Object.Width           =   917
      EndProperty
      BeginProperty ColumnHeader(4) {BDD1F052-858B-11D1-B16A-00C0F0283628} 
         SubItemIndex    =   3
         Key             =   "Column3"
         Text            =   "Column 3"
         Object.Width           =   1270
      EndProperty
   End
End
Attribute VB_Name = "frmMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Private Declare Function SendMessage Lib "user32" Alias _
"SendMessageA" (ByVal hWnd As Long, ByVal wMsg As Long, _
ByVal wParam As Long, lParam As Any) As Long

Private Const LVM_FIRST = &H1000
Private piOriginalRowCount As Integer




Private Sub cmdExit_Click()
Unload Me
End Sub

Private Sub cmdNewData_Click()
RefreshValues
End Sub

Private Sub cmdTotal_Click()
CalculateTotal
End Sub

Private Sub Form_Load()
Dim iCtr As Integer
Dim iCtr2 As Integer
Dim oCol As ColumnHeader
Dim sngTotalWidth As Single


'original row count, consisting of values to add
'adjust or calculate based on your needs
piOriginalRowCount = 3
'Trick to autosize columns based on column header
ListView1.ListItems.Add , , "TOTALS   "
For iCtr = 1 To 3
    ListView1.ListItems(1).SubItems(iCtr) = "Column1 "
Next
LV_AutoSizeColumn ListView1

'size listview based on columnwidth
For Each oCol In ListView1.ColumnHeaders
    sngTotalWidth = sngTotalWidth + oCol.Width
Next
ListView1.Width = sngTotalWidth + 60

RefreshValues


CenterControlHorizontal ListView1
CenterControlsHorizontal 105, True, cmdTotal, cmdNewData, cmdExit

End Sub

Public Sub CalculateTotal()
Dim li As ListItem
Dim iColumnCount As Integer
Dim iTotalRow As Integer
Dim iCtr As Integer
Dim iCtr2 As Integer
Dim lTotal As Long


iColumnCount = ListView1.ColumnHeaders.Count - 1
iTotalRow = piOriginalRowCount + 2

If ListView1.ListItems.Count < iTotalRow Then
    'add space
    ListView1.ListItems.Add , "SPACE", ""

    'add new item for total
    Set li = ListView1.ListItems.Add(, "TOTALS", "TOTALS")
    li.Bold = True
End If

For iCtr = 1 To iColumnCount
    lTotal = 0
    For iCtr2 = 1 To piOriginalRowCount
        lTotal = lTotal + Val(ListView1.ListItems(iCtr2).SubItems(iCtr))
    Next iCtr2
    
    ListView1.ListItems(iTotalRow).SubItems(iCtr) = lTotal
Next iCtr
End Sub
Public Function RandomNumber(ByVal MaxValue As Long, Optional _
ByVal MinValue As Long = 0)

  On Error Resume Next
  Randomize Timer
  RandomNumber = Int((MaxValue - MinValue + 1) * Rnd) + MinValue

End Function

Public Sub LV_AutoSizeColumn(LV As ListView, Optional Column _
 As ColumnHeader = Nothing)
 
 Dim C As ColumnHeader
 If Column Is Nothing Then
  For Each C In LV.ColumnHeaders
   SendMessage LV.hWnd, LVM_FIRST + 30, C.Index - 1, -1
  Next
 Else
  SendMessage LV.hWnd, LVM_FIRST + 30, Column.Index - 1, -1
 End If
 LV.Refresh
End Sub

Public Sub CenterControlHorizontal(child As Object)





Dim sngParentWidth As Single
 sngParentWidth = Me.ScaleWidth
 child.Left = (sngParentWidth - child.Width) / 2
End Sub
Public Sub CenterControlsHorizontal(space As Single, AlignTop As Boolean, ParamArray cnts())
Dim sngTotalSpace As Single
Dim i As Integer

Dim sngBaseTop As Single
Dim sngParentWidth As Single


sngParentWidth = Me.ScaleWidth

For i = 0 To UBound(cnts)
    sngTotalSpace = sngTotalSpace + cnts(i).Width
Next

sngTotalSpace = sngTotalSpace + (space * (UBound(cnts)))

cnts(0).Left = (sngParentWidth - sngTotalSpace) / 2
sngBaseTop = cnts(0).Top

For i = 1 To UBound(cnts)
    cnts(i).Left = cnts(i - 1).Left + cnts(i - 1).Width + space
    If AlignTop Then cnts(i).Top = sngBaseTop
Next

End Sub

Public Sub RefreshValues()
ListView1.ListItems.Clear
For iCtr = 1 To 3
    ListView1.ListItems.Add , , "Row" & iCtr
        For iCtr2 = 1 To 3
            ListView1.ListItems(iCtr).SubItems(iCtr2) = RandomNumber(10000)
        Next
Next
End Sub
